<template>
  <div class="login">
    <h1>Iniciar Sesión</h1>

    <form @submit.prevent="onLogin">
      <div>
        <input
          type="text"
          placeholder="Correo Electronico"
          v-model="formData.email"
          :class="{ error: formError.email }"
          class="form-control input-sm"
        />
      </div>

      <div>
        <input
          type="password"
          placeholder="Contraseña"
          v-model="formData.password"
          :class="{ error: formError.password }"
          class="form-control input-sm"
        />
      </div>
      <br />
      <button type="submit" class="btn btn-success">Iniciar sesión</button>
    </form>
    <p @click="changeForm">Crear cuenta nueva</p>
  </div>
</template>

<script>
import { ref } from "vue";
import * as Yup from "yup";
import { Auth } from "../../utils/firebase";

export default {
  name: "Login",
  props: {
    changeForm: Function,
  },

  setup() {
    let formData = {};
    let formError = ref({});

    const schemaForm = Yup.object().shape({
      email: Yup.string().email(true).required(true),
      password: Yup.string().required(true),
    });

    const onLogin = async () => {
      formError.value = {};
      try {
        await schemaForm.validate(formData, { abortEarly: false });
        try {
          const { email, password } = formData;
          await Auth.signInWithEmailAndPassword(email, password);
        } catch (error) {
          console.log(error);
        }
      } catch (err) {
        err.inner.forEach((error) => {
          formError.value[error.path] = error.message;
        });
      }
    };

    return {
      formData,
      onLogin,
      formError,
    };
  },
};
</script>

<style lang="scss" scoped>
.login {
  background-color: #fff;
  padding: 30px;
  box-shadow: 0px 0px 38px -5px rgba(0, 0, 0, 0.45);
  width: 400px;
  border-radius: 10px;

  h1 {
    text-align: center;
    margin-bottom: 30px;
    color: rgb(112, 109, 109);
  }

  form {
    input.error {
      border-color: #faa;
      background-color: #ffeded;
    }

    input {
      margin-top: 2%;
    }

    button {
      width: 100%;
      background-color: #3ab025;
    }
  }

  p {
    text-align: center;
    margin-top: 30px;

    &:hover {
      cursor: pointer;
      opacity: 0.8;
    }
  }
}
</style>
